// VcExampleDlg.cpp : implementation file
//

#include "stdafx.h"
#include "VcExample.h"
#include "VcExampleDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CVcExampleDlg dialog

CVcExampleDlg::CVcExampleDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CVcExampleDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CVcExampleDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CVcExampleDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CVcExampleDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CVcExampleDlg, CDialog)
	//{{AFX_MSG_MAP(CVcExampleDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_InitializeDevicesBUTTON, OnInitializeDevicesBUTTON)
	ON_BN_CLICKED(IDC_OPENDEVICE_BUTTON, OnOpendeviceButton)
	ON_BN_CLICKED(IDC_GETSERIALNO_BUTTON, OnGetserialnoButton)
	ON_BN_CLICKED(IDC_CHANNELNUM_BUTTON, OnChannelnumButton)
	ON_BN_CLICKED(IDC_SETNORMAL_BUTTON, OnSetnormalButton)
	ON_BN_CLICKED(IDC_STROBEPARA_BUTTON, OnStrobeparaButton)
	ON_BN_CLICKED(IDC_TRIGGERPARA_BUTTON, OnTriggerparaButton)
	ON_BN_CLICKED(IDC_SETMODE_BUTTON, OnSetmodeButton)
	ON_BN_CLICKED(IDC_GETPARA_BUTTON, OnGetparaButton)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CVcExampleDlg message handlers

BOOL CVcExampleDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	DevHandle = -1;
	SetDlgItemText(IDC_CURRENTCHANNEL_EDIT, "1" );
	
	SetDlgItemText(IDC_NORMALMAX_EDIT, "200" );
	SetDlgItemText(IDC_NORMALSET_EDIT, "10" );
	SetDlgItemText(IDC_STROBEMAX_EDIT, "1000" );
	SetDlgItemText(IDC_STROBEREPEAT_EDIT, "100" );
	SetDlgItemText(IDC_TRIGGERMAX_EDIT, "1000" );
	SetDlgItemText(IDC_TRIGGERPOLARITY_EDIT, "1" );

	((CButton*)GetDlgItem(IDC_DISABLE_RADIO))->SetCheck(1);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CVcExampleDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CVcExampleDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CVcExampleDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CVcExampleDlg::OnOK() 
{
	// TODO: Add extra validation here
	if ( DevHandle != -1 )
		MTUSB_LEDDriverCloseDevice( DevHandle );
	CDialog::OnOK();
}

void CVcExampleDlg::OnInitializeDevicesBUTTON() 
{
	int USBDevices;
	CString MyStr;

	// TODO: Add your control notification handler code here
	USBDevices = MTUSB_LEDDriverInitDevices();
	MyStr.Format( "%d", USBDevices );
	SetDlgItemText(IDC_TOTALDEVICE_STATIC, MyStr );
}

void CVcExampleDlg::OnOpendeviceButton() 
{
	// TODO: Add your control notification handler code here
	DevHandle = MTUSB_LEDDriverOpenDevice(0);
	if ( DevHandle == -1  )
	{
		MessageBox(" Device Open Failed! ");
	}
}


void CVcExampleDlg::OnGetserialnoButton() 
{
	char SerialNum[32];
	// TODO: Add your control notification handler code here
	MTUSB_LEDDriverSerialNumber( DevHandle, SerialNum, 32 );
	SetDlgItemText(IDC_SERIALNO_STATIC, CString( SerialNum ) );
}

void CVcExampleDlg::OnChannelnumButton() 
{
	int Channels;
	CString MyStr;
	// TODO: Add your control notification handler code here
	Channels = MTUSB_LEDDriverDeviceChannels( DevHandle );
	MyStr.Format( "%d", Channels );
	SetDlgItemText(IDC_CHANNELNO_STATIC, MyStr );
}

void CVcExampleDlg::OnSetnormalButton() 
{
	int Imax, Iset;
	int CurrentChannel;
	CString cs;

	// TODO: Add your control notification handler code here
	GetDlgItemText(IDC_CURRENTCHANNEL_EDIT, cs);
	sscanf(cs, "%i", &CurrentChannel);

	GetDlgItemText(IDC_NORMALMAX_EDIT, cs);
	sscanf(cs, "%i", &Imax);

	GetDlgItemText(IDC_NORMALSET_EDIT, cs);
	sscanf(cs, "%i", &Iset);

	LEDData.Normal_CurrentMax = Imax;
	LEDData.Normal_CurrentSet = Iset;
	MTUSB_LEDDriverSetNormalPara( DevHandle, CurrentChannel, &LEDData );
	MTUSB_LEDDriverSetNormalCurrent( DevHandle, CurrentChannel, Iset );
}

void CVcExampleDlg::OnStrobeparaButton() 
{
	int Imax, Repeat;
	int CurrentChannel;
	CString cs;

	// TODO: Add your control notification handler code here
	GetDlgItemText(IDC_CURRENTCHANNEL_EDIT, cs);
	sscanf(cs, "%i", &CurrentChannel);

	GetDlgItemText(IDC_STROBEMAX_EDIT, cs);
	sscanf(cs, "%i", &Imax);

	GetDlgItemText(IDC_STROBEREPEAT_EDIT, cs);
	sscanf(cs, "%i", &Repeat);

	LEDData.Strobe_CurrentMax = Imax;
	LEDData.Strobe_RepeatCnt = Repeat;
	LEDData.Strobe_Profile[0][0] = 200;
	LEDData.Strobe_Profile[0][1] = 500000 ; // Tset
    LEDData.Strobe_Profile[1][0] = 5;
    LEDData.Strobe_Profile[1][1] = 500000;
    LEDData.Strobe_Profile[2][0] = 0;
    LEDData.Strobe_Profile[2][1] = 0;
	MTUSB_LEDDriverSetStrobePara( DevHandle, CurrentChannel, &LEDData );
}

void CVcExampleDlg::OnTriggerparaButton() 
{
	int Imax, Polarity;
	int CurrentChannel;
	CString cs;

	// TODO: Add your control notification handler code here
	GetDlgItemText(IDC_CURRENTCHANNEL_EDIT, cs);
	sscanf(cs, "%i", &CurrentChannel);

	GetDlgItemText(IDC_TRIGGERMAX_EDIT, cs);
	sscanf(cs, "%i", &Imax);

	GetDlgItemText(IDC_TRIGGERPOLARITY_EDIT, cs);
	sscanf(cs, "%i", &Polarity);

	LEDData.Trigger_CurrentMax = Imax;
	LEDData.Trigger_Polarity = Polarity;
	LEDData.Trigger_Profile[0][0] = 100;
	LEDData.Trigger_Profile[0][1] = 50000 ; // Tset
    LEDData.Trigger_Profile[1][0] = 0; //5;
    LEDData.Trigger_Profile[1][1] = 0; //500000;
    //LEDData.Trigger_Profile[2][0] = 0;
    //LEDData.Trigger_Profile[2][1] = 0;
	MTUSB_LEDDriverSetTriggerPara( DevHandle, CurrentChannel, &LEDData );	
}

void CVcExampleDlg::OnSetmodeButton() 
{
	int CurrentMode;
	int CurrentChannel;
	CString cs;

	// TODO: Add your control notification handler code here
	GetDlgItemText(IDC_CURRENTCHANNEL_EDIT, cs);
	sscanf(cs, "%i", &CurrentChannel);

	if ( IsDlgButtonChecked(IDC_DISABLE_RADIO) )
		CurrentMode = 0;
	if ( IsDlgButtonChecked(IDC_NORMAL_RADIO) )
		CurrentMode = 1;
	if ( IsDlgButtonChecked(IDC_STROBE_RADIO) )
		CurrentMode = 2;
	if ( IsDlgButtonChecked(IDC_TRIGGER_RADIO) )
		CurrentMode = 3;

	MTUSB_LEDDriverSetMode( DevHandle, CurrentChannel, CurrentMode );
}

void CVcExampleDlg::OnGetparaButton() 
{
	int CurrentChannel;
	CString cs;
	int Mode;
	TLedChannelData ParaData; 

	// TODO: Add your control notification handler code here
	GetDlgItemText(IDC_CURRENTCHANNEL_EDIT, cs);
	sscanf(cs, "%i", &CurrentChannel);
	
	MTUSB_LEDDriverGetCurrentPara( DevHandle, CurrentChannel, &ParaData, &Mode );
}
