unit Dllinterface;

interface

uses 
	DataTypes;
	
// General functions
function MTUSB_LEDDriverInitDevices() : integer; cdecl;
function MTUSB_LEDDriverOpenDevice( DeviceIndex : integer ) : integer; cdecl;
function MTUSB_LEDDriverCloseDevice( DevHandle : integer ) : integer; cdecl;
function MTUSB_LEDDriverSerialNumber( DevHandle : integer; SerNumber : PChar; Size : integer ) : integer; cdecl;
function MTUSB_LEDDriverDeviceChannels( DevHandle : integer ) : integer; cdecl;
function MTUSB_LEDDriverDeviceModuleType( DevHandle : integer ) : integer; cdecl;
function MTUSB_LEDDriverSetMode( DevHandle : integer; Channel : integer; Mode : integer ) : integer; cdecl;
function MTUSB_LEDDriverSetNormalPara( DevHandle : integer; Channel : integer;
                        ChannelParaPtr : PLedChannelData ) : integer; cdecl;
function MTUSB_LEDDriverSetNormalCurrent( DevHandle : integer; Channel : integer;
                        Current : integer ) : integer; cdecl;
function MTUSB_LEDDriverSetStrobePara(DevHandle : integer; Channel : integer;
                        ChannelParaPtr : PLedChannelData ) : integer; cdecl;
function MTUSB_LEDDriverSetTriggerPara(DevHandle : integer; Channel : integer;
                        ChannelParaPtr : PLedChannelData ) : integer; cdecl;
function MTUSB_LEDDriverResetDevice( DevHandle : integer ) : integer ; cdecl;
function MTUSB_LEDDriverStorePara( DevHandle : integer ) : integer ; cdecl;
function MTUSB_LEDDriverRestoreDefault( DevHandle : integer ) : integer ; cdecl;
function MTUSB_LEDDriverGetLoadVoltage( DevHandle : integer ; Channel : integer ) : integer ; cdecl;
function MTUSB_LEDDriverSendCommand( DevHandle : integer ; CommandString : PChar ) : integer ; cdecl;

implementation


function MTUSB_LEDDriverInitDevices; external 'Mightex_LEDDriver_SDK.dll' name 'MTUSB_LEDDriverInitDevices';
function MTUSB_LEDDriverOpenDevice; external 'Mightex_LEDDriver_SDK.dll' name 'MTUSB_LEDDriverOpenDevice';
function MTUSB_LEDDriverCloseDevice; external 'Mightex_LEDDriver_SDK.dll' name 'MTUSB_LEDDriverCloseDevice';
function MTUSB_LEDDriverSerialNumber; external 'Mightex_LEDDriver_SDK.dll' name 'MTUSB_LEDDriverSerialNumber';
function MTUSB_LEDDriverDeviceChannels; external 'Mightex_LEDDriver_SDK.dll' name 'MTUSB_LEDDriverDeviceChannels';
function MTUSB_LEDDriverDeviceModuleType; external 'Mightex_LEDDriver_SDK.dll' name 'MTUSB_LEDDriverDeviceModuleType';
function MTUSB_LEDDriverSetMode; external 'Mightex_LEDDriver_SDK.dll' name 'MTUSB_LEDDriverSetMode';
function MTUSB_LEDDriverSetNormalPara; external 'Mightex_LEDDriver_SDK.dll' name 'MTUSB_LEDDriverSetNormalPara';
function MTUSB_LEDDriverSetNormalCurrent; external 'Mightex_LEDDriver_SDK.dll' name 'MTUSB_LEDDriverSetNormalCurrent';
function MTUSB_LEDDriverSetStrobePara; external 'Mightex_LEDDriver_SDK.dll' name 'MTUSB_LEDDriverSetStrobePara';
function MTUSB_LEDDriverSetTriggerPara; external 'Mightex_LEDDriver_SDK.dll' name 'MTUSB_LEDDriverSetTriggerPara';
function MTUSB_LEDDriverResetDevice; external 'Mightex_LEDDriver_SDK.dll' name 'MTUSB_LEDDriverResetDevice';
function MTUSB_LEDDriverStorePara;external 'Mightex_LEDDriver_SDK.dll' name 'MTUSB_LEDDriverStorePara';
function MTUSB_LEDDriverRestoreDefault;external 'Mightex_LEDDriver_SDK.dll' name 'MTUSB_LEDDriverRestoreDefault';
function MTUSB_LEDDriverGetLoadVoltage;external 'Mightex_LEDDriver_SDK.dll' name 'MTUSB_LEDDriverGetLoadVoltage';
function MTUSB_LEDDriverSendCommand; external 'Mightex_LEDDriver_SDK.dll' name 'MTUSB_LEDDriverSendCommand';

end.
