Attribute VB_Name = "Module1"
Option Explicit
'Dim WinVersion As Integer, SoundAvailable As Integer
'Public VisibleFrame As Frame

Public Const MAX_PROFILE_ITEM = 256 '128*2

Public Const DISABLE_MODE = 0
Public Const NORMAL_MODE = 1
Public Const STROBE_MODE = 2
Public Const TRIGGER_MODE = 3

Public Const MODULE_AA = 0
Public Const MODULE_AV = 1
Public Const MODULE_SA = 2
Public Const MODULE_SV = 3
Public Const MODULE_MA = 4
Public Const MODULE_CA = 5
Public Const MODULE_HA = 6
Public Const MODULE_HV = 7
Public Const MODULE_FA = 8
Public Const MODULE_FV = 9
Public Const MODULE_XA = 10
Public Const MODULE_XV = 11


Public Type TLEDCHANNELDATA
    Normal_CurrentMax As Long
    Normal_CurrentSet As Long

    Strobe_CurrentMax As Long
    Strobe_RepeatCnt As Long
    ' Maximum 128 Pairs of (Iset,Tset), totally 256 values.
    Strobe_Profile(MAX_PROFILE_ITEM - 1) As Long

    Trigger_CurrentMax As Long
    Trigger_Polarity As Long
    ' Maximum 128 Pairs of (Iset,Tset), totally 256 values.
    Trigger_Profile(MAX_PROFILE_ITEM - 1) As Long
End Type


Declare Function MTUSB_LEDDriverInitDevices Lib "Mightex_LEDDriver_SDK_Stdcall" () As Long
Declare Function MTUSB_LEDDriverOpenDevice Lib "Mightex_LEDDriver_SDK_Stdcall" (ByVal DeviceIndex As Long) As Long
Declare Function MTUSB_LEDDriverCloseDevice Lib "Mightex_LEDDriver_SDK_Stdcall" (ByVal DevHandle As Long) As Long
Declare Function MTUSB_LEDDriverSerialNumber Lib "Mightex_LEDDriver_SDK_Stdcall" (ByVal DevHandle As Long, ByVal SerNumber As String, ByVal SerSize As Long) As Long
Declare Function MTUSB_LEDDriverDeviceChannels Lib "Mightex_LEDDriver_SDK_Stdcall" (ByVal DevHandle As Long) As Long
Declare Function MTUSB_LEDDriverDeviceModuleType Lib "Mightex_LEDDriver_SDK_Stdcall" (ByVal DevHandle As Long) As Long
Declare Function MTUSB_LEDDriverSetMode Lib "Mightex_LEDDriver_SDK_Stdcall" (ByVal DevHandle As Long, ByVal Channel As Long, ByVal Mode As Long) As Long
Declare Function MTUSB_LEDDriverSetNormalPara Lib "Mightex_LEDDriver_SDK_Stdcall" (ByVal DevHandle As Long, ByVal Channel As Long, ByRef lpLEDChannelData As TLEDCHANNELDATA) As Long
Declare Function MTUSB_LEDDriverSetNormalCurrent Lib "Mightex_LEDDriver_SDK_Stdcall" (ByVal DevHandle As Long, ByVal Channel As Long, ByVal Current As Long) As Long
Declare Function MTUSB_LEDDriverSetStrobePara Lib "Mightex_LEDDriver_SDK_Stdcall" (ByVal DevHandle As Long, ByVal Channel As Long, ByRef lpLEDChannelData As TLEDCHANNELDATA) As Long
Declare Function MTUSB_LEDDriverSetTriggerPara Lib "Mightex_LEDDriver_SDK_Stdcall" (ByVal DevHandle As Long, ByVal Channel As Long, ByRef lpLEDChannelData As TLEDCHANNELDATA) As Long
Declare Function MTUSB_LEDDriverResetDevice Lib "Mightex_LEDDriver_SDK_Stdcall" (ByVal DevHandle As Long) As Long
Declare Function MTUSB_LEDDriverStorePara Lib "Mightex_LEDDriver_SDK_Stdcall" (ByVal DevHandle As Long) As Long
Declare Function MTUSB_LEDDriverRestoreDefault Lib "Mightex_LEDDriver_SDK_Stdcall" (ByVal DevHandle As Long) As Long
Declare Function MTUSB_LEDDriverGetLoadVoltage Lib "Mightex_LEDDriver_SDK_Stdcall" (ByVal DevHandle As Long, ByVal Channel As Long) As Long
Declare Function MTUSB_LEDDriverGetCurrentPara Lib "Mightex_LEDDriver_SDK_Stdcall" (ByVal DevHandle As Long, ByVal Channel As Long, ByRef lpLEDChannelData As TLEDCHANNELDATA, ByRef Mode As Long) As Long
Declare Function MTUSB_LEDDriverSendCommand Lib "Mightex_LEDDriver_SDK_Stdcall" (ByVal DevHandle As Long, ByVal CommandString As String) As Long




